import simulation
from agent import DQNAgent
import keras
import numpy as np


if __name__ == "__main__":
    # initialize gym environment and the agent
    env = simulation.SimState()
    player  = DQNAgent()
    # Iterate the game
    for e in range(2000):
        # reset state in the beginning of each game
        env.reset()
        state,_,_ = env.frame_step(1)
        # time_t represents each frame of the gam
        # Our goal is to keep the pole upright as long as possible until score of 500
        # the more time_t the more score
        for time_t in range(100000):

            # turn this on if you want to render
            # env.render()
            # Decide action
            action = player.act(state)
            # Advance the game to the next frame based on the action.
            # Reward is 1 for every frame the pole survived
            next_state, reward, done = env.frame_step(action)
            #next_state = np.reshape(next_state, [1, 4])
            # Remember the previous state, action, reward, and done
            player.remember(state, action, reward, next_state, done)
            # make next_state the new current state for the next frame.
            state = next_state
            # done becomes True when the game ends
            # ex) The agent drops the pole
            if done:
                # print the score and break out of the loop
                print("episode: {}, score: {}"
                      .format(e, time_t))
                break
        # train the agent with the experience of the episode
        player.replay(10)

    # serialize model to JSON
    model_json = model.to_json()
    with open("model.json", "w") as json_file:
        json_file.write(model_json)
        # serialize weights to HDF5
    model.save_weights("model.h5")
    print("Saved model to disk")
 